app/urls.py
from django.conf.urls import url, include
from . import views
# from dchq_deploy.views import taskstatus
from django.conf import settings

urlpatterns = [
    url(r'^$', views.DashboardPage.as_view(template_name='app/app_list.html'), name='dashboard'),
    url(r'^poll_state$', views.poll_state,name='poll_state'),
    url(r'^create/(?P<pk>[^/]+)?$', views.app_create, name='app_create'),
    url(r'^create/$', views.app_create, name='app_create'),
    url(r'^(?P<pk>\d+)/delete/$', views.app_delete, name='app_delete'),
    url(r'^info/id/(?:(?P<pk>[^/]+))?/$', views.app_detail, name='app_info_poll'),
    url(r'^check_app_detail/$', views.check_app_detail, name='check_app_detail')
]


if settings.DEBUG:
    import debug_toolbar

    urlpatterns += [
        url(r'^__debug__/', include(debug_toolbar.urls)),
    ]

config/urls.py
from django.conf import settings
from django.conf.urls import include, url
from django.conf.urls.static import static
from django.contrib import admin
from django.views.generic import TemplateView
from django.views import defaults as default_views

from config.views import TemplateListView

urlpatterns = [
    url(r'^$', TemplateListView.as_view(), name='home'),
    url(r'^about/$', TemplateView.as_view(template_name='pages/about.html'), name='about'),

    # Django Admin, use {% url 'admin:index' %}
    url(settings.ADMIN_URL, admin.site.urls),

    # User management
    url(r'^users/', include('cooke_dchq_project.users.urls', namespace='users')),
    url(r'^accounts/', include('allauth.urls')),

    # Your stuff: custom urls includes go here
    url(r'^app/', include('app.urls')),

] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

if settings.DEBUG:
    # This allows the error pages to be debugged during development, just visit
    # these url in browser to see how these error pages look like.
    urlpatterns += [
        url(r'^400/$', default_views.bad_request, kwargs={'exception': Exception('Bad Request!')}),
        url(r'^403/$', default_views.permission_denied, kwargs={'exception': Exception('Permission Denied')}),
        url(r'^404/$', default_views.page_not_found, kwargs={'exception': Exception('Page not Found')}),
        url(r'^500/$', default_views.server_error),
    ]
    if 'debug_toolbar' in settings.INSTALLED_APPS:
        import debug_toolbar
        urlpatterns = [
            url(r'^__debug__/', include(debug_toolbar.urls)),
        ] + urlpatterns

cooke_dchq_project/users/urls.py
from django.conf.urls import url, include

from . import views

urlpatterns = [
    url(
        regex=r'^$',
        view=views.UserListView.as_view(),
        name='list'
    ),
    url(
        regex=r'^~redirect/$',
        view=views.UserRedirectView.as_view(),
        name='redirect'
    ),
    url(
        regex=r'^(?P<username>[\w.@+-]+)/$',
        view=views.UserDetailView.as_view(),
        name='detail'
    ),
    url(
        regex=r'^~update/$',
        view=views.UserUpdateView.as_view(),
        name='update'
    ),
]

cooke_dchq_project/users/models.py
from django.contrib.auth.models import AbstractUser
from django.core.urlresolvers import reverse
from django.db import models
from django.utils.encoding import python_2_unicode_compatible
from django.utils.translation import ugettext_lazy as _


@python_2_unicode_compatible
class User(AbstractUser):

    # First Name and Last Name do not cover name patterns
    # around the globe.
    name = models.CharField(_('Name of User'), blank=True, max_length=255)

    def __str__(self):
        return self.username

    def get_absolute_url(self):
        return reverse('users:detail', kwargs={'username': self.username})

cooke_dchq_project/users/views.py
from django.core.urlresolvers import reverse
from django.views.generic import DetailView, ListView, RedirectView, UpdateView

from django.contrib.auth.mixins import LoginRequiredMixin

from .models import User


class UserDetailView(LoginRequiredMixin, DetailView):
    model = User
    # These next two lines tell the view to index lookups by username
    slug_field = 'username'
    slug_url_kwarg = 'username'


class UserRedirectView(LoginRequiredMixin, RedirectView):
    permanent = False

    def get_redirect_url(self):
        return reverse('users:detail',
                       kwargs={'username': self.request.user.username})


class UserUpdateView(LoginRequiredMixin, UpdateView):

    fields = ['name', ]

    # we already imported User in the view code above, remember?
    model = User

    # send the user back to their own page after a successful update
    def get_success_url(self):
        return reverse('users:detail',
                       kwargs={'username': self.request.user.username})

    def get_object(self):
        # Only get the User record for the user making the request
        return User.objects.get(username=self.request.user.username)


class UserListView(LoginRequiredMixin, ListView):
    model = User
    # These next two lines tell the view to index lookups by username
    slug_field = 'username'
    slug_url_kwarg = 'username'

cooke_dchq_project/templates/users/user_detail.html
{% extends "base.html" %}
{% load static %}

{% block title %}User: {{ object.username }}{% endblock %}

{% block content %}
    <div class="container">

        <div class="row">
            <div class="col-md-8">

                <h2>{{ object.username }}</h2>
                {% if object.name %}
                    <p>{{ object.name }}</p>
                {% endif %}
            </div>
        </div>

        {% if object == request.user %}
            <!-- Action buttons -->
            <div class="row">

                <div class="col-md-8">
                    <a class="btn btn-primary" href="{% url 'users:update' %}" role="button">My Info</a>
                    <a class="btn btn-primary" href="{% url 'account_email' %}" role="button">E-Mail</a>
                    <!-- Your Stuff: Custom user template urls -->
                </div>

                <div class="col-md-4 hidden-xs">
                    <img src="http://websamplenow.com/30/userprofile/images/avatar.jpg"
                         class="img-responsive img-thumbnail ">
                    <form class="form-horizontal">
                        <fieldset>
                            <!-- File Button -->
                            <div class="form-group">
                                <label class="col-md-12 control-label" for="Upload photo">Upload photo</label>
                                <div class="col-md-4">
                                    <input id="Upload photo" name="Upload photo" class="input-file" type="file">
                                </div>
                                <div class="form-group">
                                    <label class="col-md-4 control-label"></label>
                                    <div class="col-md-12">
                                        <a href="#" class="btn btn-success"><span
                                                class="glyphicon glyphicon-thumbs-up"></span>
                                            Save</a>
                                    </div>
                                </div>
                            </div>
                        </fieldset>
                    </form>
                </div>
            </div>
            </div>
            <!-- End Action buttons -->

        {% endif %}

{% endblock content %}

cooke_dchq_project/templates/users/user_form.html
{% extends "base.html" %}
{% load crispy_forms_tags %}

{% block title %}{{ user.username }}{% endblock %}

{% block content %}
  <h1>{{ user.username }}</h1>
  <form class="form-horizontal" method="post" action="{% url 'users:update' %}">
    {% csrf_token %}
    {{ form|crispy }}
    <div class="control-group">
      <div class="controls">
        <button type="submit" class="btn">Update</button>
      </div>
    </div>
  </form>
{% endblock %}

cooke_dchq_project/templates/users/user_list.html
{% extends "base.html" %}
{% load static i18n %}
{% block title %}Members{% endblock %}

{% block content %}
<div class="container">
  <h2>Users</h2>

  <div class="list-group">
    {% for user in user_list %}
      <a href="{% url 'users:detail' user.username %}" class="list-group-item">
        <h4 class="list-group-item-heading">{{ user.username }}</h4>
      </a>
    {% endfor %}
  </div>
</div>
{% endblock content %}